function [dst,cwh,clm] = mcontoursd(pict,cfs,nlevs)
% MCONTOURSD - 2D transformace ContourletSD s omezenim poctu koeficientu pro rekonstrukci
%   MCONTOURSD ziska pro vstupni obraz PICT vystup DST s omezenym poctem
%   nejvyznamnejsich koeficientu udavanou hodnotou CFS do urovne dekompozice 
%   NLEVS. Do NLEVS se uklada pocet smeru na jednotlivych urovnich dekompozice.
%   Hodnoty NLEVS jsou cela kladna cisla. Cisla jsou oddelena mezerou.
%   Priklad zapisu NLEVS: [0 1 2 2 4 8]
%   Jako vstup se zadava primo nazev souboru.
% 
%   Obecny tvar funkce:
%   [DST,CWH,CLM] = MCONTOURSD(PICT,CFS,NLEVS)
% 
%   !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
%   !!! POZOR!!! Transformace pracuje s obrazky stejneho rozmeru!!!
%   !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
% 
%   Krome omezeneho vystupu se ziskaji koeficienty vstupniho a vystupniho 
%   obrazu CWH a CLM. Koeficienty lze zobrazit pomoci SHOWPDFB a CONT2IM.
% 
%   Funkce dale urci hodnoty PSNR, SNR a MSE, ktere vypise do konzole.
% 
%   Priklad zadavani funkce:
%   [dst,cwh,clm] = mcontoursd('lena.png',5000,[1 2 2 4 8]);
% 
%   ContourletSD byl stazen z:
%   http://lu.seas.harvard.edu/code/ContourletSD.zip
% 
%   Clanek:
%   Yue M. Lu, Minh N. Do
%   A new contourlet transform with sharp frequency localization
%   http://lu.seas.harvard.edu/papers/ContourletSD.pdf

%% Nacteni obrazku a nastaveni filtru
x = imread(pict);
x = x(:,:,1); % Omezeni na jednu hladina v pripade barevneho obrazku
smooth_func = @rcos; % Filtr pouzity  ve viceurovnove dekompozici
Pyrmode = 2;    % 1, 1.5, 2 - Faktor nadbytecnosti: 2.33, 1.59, a 1.33
                % v zavislosti na zvolenem Pyrmode
                % Znaci mod dekompozice
dfilt = 'pkva'; % Nazev filtru smerove dekompozice
%% Viceurovnova dekompozice
cwh = ContourletSDDec(double(x), nlevs, Pyrmode, smooth_func, dfilt);
%% Omezeni na CFS keoficientu
[c, s] = pdfb2vec(cwh); % Vystup dekompozice do radkoveho vektoru
len = length(c);
CC = zeros(1,len); % Definice vystupni promenne
[~,b]=sort(abs(c),'descend'); % Serazeni koeficientu sestupne     
%======== Zapsani zvoleneho poctu koeficientu do CC ========%
i = 1;
while i < len+1 && i<cfs+1
    CC(b(i)) =c(b(i));
    i = i+1;
end
%===========================================================%
clm = vec2pdfb(CC, s); % Radkovy vektor do tvaru povudni dekompozice
%% Rekonstrukce z omezeneho poctu koeficientu
dst = ContourletSDRec(clm, Pyrmode, smooth_func, dfilt);
%% Vypocty, SNR, PSNR, MSE
xx = double(x)/256;
xhat1 = (double(dst)/256);
error = mean(mean(((xx)-(xhat1)).^2));  %MSE
err = xx - xhat1;
err = err(:);
PSNRdb = 10 * log10(1/mean(err .^2));   %PSNR
ssm = ssim(x,dst);
% snr = -10*log10( sum((xx(:) - xhat1(:)).^2) / sum(xx(:).^2)); %SNR
snr = 10 * log10(var(xx(:), 1) / mean(err(:).^2)); %SNR
%% Vypis hodnot do konzole
disp('ContourletSD transform');
disp(' ');
disp(['Transformace pro ',num2str(cfs),' koeficientu']);
disp(' ');
if  cfs > len
    disp('!!!Zadany pocet koeficientu je vetsi nez celkovy pocet koeficientu!!!')
    disp(['!!!Vysledek je zobrazen pro ',num2str(i-1),' koeficientu!!!']);
    disp(' ');
end
disp(['PSNR = ',num2str(PSNRdb),'dB']);
disp(['SNR  = ',num2str(snr),'dB']);
disp(['MSE  = ',num2str(error)]);
disp(['SSIM = ',num2str(ssm)]);
disp(' ');
disp(' ');
dst = uint8(dst);